//
// --- initialise the functions
//
exec('Optimisation_Start.sci');
//
// --- initialise the data
//
global NumberOfDesvars NArraySize messages
global BestTarget
global DesignStart BestDesign

DesignStart = ones (100,1);
[Target,DesignStart,DesignMin,DesignMax] = SCILAB_RMOD_K_INIT(DesignStart);
BestTarget = 1.0e+10;  
messages   = 3;
//
// --- initialise the optimisation
//
myplotfun = list ( optimplotfval , optimplotx  );
rand("seed" , 0)
nm = neldermead_new ();
nm = neldermead_configure(nm,"-numberofvariables",size(DesignMin,1));
nm = neldermead_configure(nm,"-function",SCILAB_RMOD_K_NM);
nm = neldermead_configure(nm,"-x0",DesignStart);
nm = neldermead_configure(nm,"-method","box");
nm = neldermead_configure(nm,"-boundsmin",DesignMin');
nm = neldermead_configure(nm,"-boundsmax",DesignMax');
nm = neldermead_configure(nm,"-maxfunevals",1000);
nm = neldermead_configure(nm,"-maxiter",1000);
nm = neldermead_configure(nm,"-simplex0method","randbounds");
//nm = neldermead_configure(nm,"-simplex0method","axes");
nm = neldermead_configure(nm,"-outputcommand",neldermead_defaultoutput);
nm = neldermead_search(nm);
x  = neldermead_get(nm,"-xopt") 
fval = neldermead_get(nm,"-fopt") 
dos ('copy DesignResults.dat DesignStart.dat')
//
// --- perform the optimisation
//
myplotfun = list ( optimplotfval , optimplotx  );
opt = optimset ("Display","iter",...
               "FunValCheck","on",...
               "MaxFunEvals",600,...
               "MaxIter",600,...
               "PlotFcns",myplotfun,...
               "TolFun",1.e-12,...
               "TolX",1.e-13)
               
[x fval] = fminsearch ( SCILAB_RMOD_K ,DesignStart ,opt );
//
// --- terminate the function
//
Target2 = SCILAB_RMOD_K_TERMINATE(BestDesign)
dos ('copy DesignResults.dat DesignStart.dat')
nm = neldermead_destroy(nm);
