//
// --- clean memory and screen, NArraySize is the dimension of the workspace (> 3*NumberOfModelParameters)
//
funcprot(0);
mode(0); 
format('v');
clc;
clear;
ulink(); 
link("SCILAB-RMOD-K-Formula.dll","RMOD_K_SCIFunction","c")
NArraySize = 200;
//
// --- get information about the optimsation problem, starting values and bounds from input file
//
function [Target,DesignStart,DesignMin,DesignMax] = SCILAB_RMOD_K_INIT (design)
    global NArraySize NumberOfDesvars
    mymode = 0.0;
    mysize = NArraySize;
    OutputArray = ones(mysize,1);
    [Target,OutputArray] = call("RMOD_K_SCIFunction",design,1,"d",mymode,2,"d",...
                                "out",[1,1],3,"d",[mysize,1],4,"d");
     NumberOfDesvars = int32(Target);
     DesignStart = ones (NumberOfDesvars,1);
     DesignMin   = ones (NumberOfDesvars,1);
     DesignMax   = ones (NumberOfDesvars,1);          
     for i=1:NumberOfDesvars
        DesignStart(i) = OutputArray(i);
        DesignMin(i)   = OutputArray(i+NumberOfDesvars);
        DesignMax(i)   = OutputArray(i+NumberOfDesvars*2);                
     end  
endfunction
//
// --- terminate run a free memory
//
function Target = SCILAB_RMOD_K_TERMINATE (design)
    global NArraySize
    mymode = -1.0;
    mysize = NArraySize;   
    CurrentDesign = ones(mysize,1);    
    [Target,CurrentDesign] = call("RMOD_K_SCIFunction",design,1,"d",mymode,2,"d",...
                                  "out",[1,1],3,"d",[mysize,1],4,"d");
endfunction
//
// --- call the function to get target values
//
function [Target] = SCILAB_RMOD_K (thedesign) 
    global NArraySize method
    global BestDesign
    global BestTarget    
    mymode = 1.0;     
    mysize = NArraySize;
    CurrentDesign = ones(mysize,1);
    [Target,CurrentDesign] = call("RMOD_K_SCIFunction",thedesign,1,"d",mymode,2,"d",...
                                  "out",[1,1],3,"d",[mysize,1],4,"d");  
    if ( Target < BestTarget ) then
        BestTarget = Target;
        BestDesign = thedesign;
        if ( messages == 2 ) 
            mprintf ("\n Current best target value = %g\n",Target)
        end    
    end
endfunction

function [Target,index] = SCILAB_RMOD_K_NM (thedesign,index) 
    global NArraySize method
    global BestDesign
    global BestTarget    
    mymode = 1.0;    
    mysize = NArraySize;
    CurrentDesign = ones(mysize,1);
    [Target,CurrentDesign] = call("RMOD_K_SCIFunction",thedesign,1,"d",mymode,2,"d",...
                                  "out",[1,1],3,"d",[mysize,1],4,"d");  
    if ( Target < BestTarget ) then
        BestTarget = Target;
        BestDesign = thedesign;
        if ( messages == 2 ) 
            mprintf ("\n Current best target value = %g\n",Target)
        end    
    end
endfunction
