%
clc;
clear all;
format short g
%
% --- state space block parameters, units [N,s,mm]
%
R     =   333.0;
Rdyn  =   315.0;
cphi  =     1.0e+08; 
dphi  =     4.0e+04;
JB    =   550.0;
Tend  =     2.0;
%
% --- input block parameters
%
Fz0  = 5000.0;
Fz1  = 1000.0;
fFz  =    2.0*pi*1.0;
sy0  =    0.0;
sy1  =   11.0;
fsy  =    2.0*pi*4.0;
gam0 =    0.17;
gam1 =    0.17;
fgam =    2.0*pi*2.0;
Omy0 =   31.25;
Omy1 =    5.00;
fOmy =    2.0*pi*1.0;
V0   =    Rdyn*Omy0;
V1   =    0.0;
fV   =    2.0*pi*0.0;
%
% --- state space block matrixes
%
A = [  0.0,         1.0;  %phib   
     -cphi/JB, -dphi/JB]; %phibd
  
B = [  0.0;  % Fx    
     -R/JB];  
 
C  = [0.0,1.0];
D  = [0.0];
X0 = [0.0,0.0]; 
 