#pragma once
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include "FormulaDefines.h"

class CContinusFormula
{
public:
   CContinusFormula( void );
  ~CContinusFormula( void );

   int  ContinusFormula_SetVariables  ( const double *formulavalues, const int nmodelparameter );
   int  ContinusFormula_SetVariables  (       double *formulavalues, const double *formuladesigns, const int *isdesvar );
   void ContinusFormula_Evaluate      ( const double *X, double *Y );
   void ContinusFormula_Terminate     ( );

   inline void   set_version ( int ivalue ) { version = ivalue;};
   inline int    get_sliding  () {return ( 0 );};
   inline int    get_version  () {return version;};
   inline double get_area     () {return h*b;};
   inline double get_length   () {return h;};
   inline double get_width    () {return b;};

protected:

   int    islide,Nmodelparameter,version;

   double cx0,cx1,cx2,cy0,cy1,cy2,soff,mue,Fz,mue0Fz,h,b;
   double sx0,sy0,mueFz,frica0,frica1,vx,vy;
   double mue1xp,cmuexp,mue1xn,cmuexn;
   double mue1yp,cmueyp,mue1yn,cmueyn;
   double pi,cR,R,mue0,pin,Fzbar,vslide0,MzScaleP,MzScaleN;
};
