#include "mexFunction.h"
#pragma comment(lib, "libmx.lib")
#pragma comment(lib, "libmat.lib")
#pragma comment(lib, "libmex.lib")
//
#include "RMOD_K_Formula_Opti.h"
//
// --- the standard interface to matlab
//
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[] )
{
   int     m1,m2;
   double *input1,*input2,*output;

   static CRMOD_K_Formula_Opti RMOD_K_Formula;
//
// --- check number of input arguments, disable solution if out of order
//
   if ( nrhs != 2 )
   {
      printf ( " number of arguments should be 2: array of design variables, number of calls \n" );
      return;
   }
//
// --- connect output array to plhs
//
   nlhs    = 1;
   plhs[0] = mxCreateDoubleMatrix( 1,1,mxREAL );
   output  = mxGetPr( plhs[0] );
//
// --- check dimension of input1 arguments, disable solution if out of order
//
   m1 = mxGetM ( prhs[0] );
   if ( m1 != Ninput1 )
   {
      printf ( " number of arguments 1 should be %d: array of design variables\n",Ninput1 );
      *output = 1.0e+15;
      return;
   }
   input1 = mxGetPr( prhs[0] );
//
// --- check dimension of input2 arguments, disable solution if out of order
//
   m2 = mxGetM ( prhs[1] );
   if ( m2 != 1 )
   {
      printf ( " dimension of argument 2 should be 1: number of calls \n" );
      *output = 1.0e+15;
      return;
   }
   input2 = mxGetPr( prhs[1] );
//
// --- call the formula
//
   *output = RMOD_K_Formula.Set_TargetValue ( input1,input2 );
}



