#pragma once
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include <stdio.h>
#include "FormulaDefines.h"

namespace FormulaGUI {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

   public ref class COpenGLPlot: public System::Windows::Forms::NativeWindow
   {
		private:
			inline void DestroyOpenGLWindow()  { this->DestroyHandle(); }
			void CreateOpenGLWindow(GLsizei iWidth, GLsizei iHeight);
			CreateParams     ^OpenGLWindow;   
	   
		public: 
			 System::Windows::Forms::Panel ^ParentForm;

			 COpenGLPlot(System::Windows::Forms::Panel^ parent, GLsizei iWidth, GLsizei iHeight); // Dynamische Erstellung verwendet geschtzten Konstruktor
			~COpenGLPlot(System::Void);

			inline void Set_UserScale (bool bvalue)    { UserScale = bvalue;};

			inline void Set_MeaData  (double *pointer) { optidata = pointer; };
			inline void Set_SimData  (double *pointer) { resultdata = pointer; };
			inline void Set_MeainfoD (int    *pointer) { TargetDirectionPerFile = pointer; };
			inline void Set_MeainfoN (int    *pointer) { PointsPerFile = pointer; };
			inline void Set_MeainfoF (int      ivalue) { NumberOfFiles = ivalue; };
			inline void Set_MeainfoA (int      ivalue) { NumberOfAdditionalFiles = ivalue; };
			inline void Set_Logfile  (FILE*  FPOINTER) { LOGFILE = FPOINTER; }; 
			inline void Set_M        (int      ivalue) { DoM              = ivalue; };
			inline void Set_MA       (int      ivalue) { DoMA             = ivalue; };
			inline void Set_F        (int      ivalue) { DoF              = ivalue; };
			inline void Set_FST      (int      ivalue) { DoFST            = ivalue; };
			inline void Set_FSL      (int      ivalue) { DoFSL            = ivalue; };
			inline void Set_RANGE    (int      ivalue) { DoMRange         = ivalue; };
			inline void Set_Files    (int      ivalue) { DoFiles          = ivalue; };
			inline void Set_Time     (int      ivalue) { DoTime           = ivalue; };
			inline void Set_TargetF  (int      ivalue) { DoTargetFunction = ivalue; };
			inline void Set_TargetP  (int      ivalue) { DoTargetPoint    = ivalue; };

			inline void Set_Fxmax      (double    value) { UFxmax      = value; };
			inline void Set_Fxmin  	 	(double    value) { UFxmin      = value; };
			inline void Set_Fymax  	 	(double    value) { UFymax      = value; };
			inline void Set_Fymin  	 	(double    value) { UFymin      = value; };
			inline void Set_sxmax  	 	(double    value) { Usxmax      = value; };
			inline void Set_sxmin  	 	(double    value) { Usxmin      = value; };
			inline void Set_symax  	 	(double    value) { Usymax      = value; };
			inline void Set_symin  	 	(double    value) { Usymin      = value; };
			inline void Set_TargetFmax (double    value) { UTargetFmax = value; };
			inline void Set_TargetPmax	(double    value) { UTargetPmax = value; };

			inline bool Get_UserScale               () { return UserScale;};

			inline double Get_Fxmax                 () { return UFxmax; };
			inline double Get_Fxmin		   	       () { return UFxmin; };
			inline double Get_Fymax		   		    () { return UFymax; };
			inline double Get_Fymin		   		    () { return UFymin; };
			inline double Get_sxmax		   		    () { return Usxmax; };
			inline double Get_sxmin		   		    () { return Usxmin; };
			inline double Get_symax		   		    () { return Usymax; };
			inline double Get_symin		   		    () { return Usymin; };
			inline double Get_TargetFmax      	    () { return UTargetFmax; };
			inline double Get_TargetPmax	   		 () { return UTargetPmax; };
															   
			void Set_Background (float a, float r, float g, float b) 
			{
				ColorA = (float) (a/255.0);
				ColorR = (float) (r/255.0);
				ColorG = (float) (g/255.0);
				ColorB = (float) (b/255.0);
			}

			void Set_MeaForce (float a, float r, float g, float b) 
			{
				ColorA1 = (float) (a/255.0);
				ColorR1 = (float) (r/255.0);
				ColorG1 = (float) (g/255.0);
				ColorB1 = (float) (b/255.0);
			}

			void Set_SimForce (float a, float r, float g, float b) 
			{
				ColorA2 = (float) (a/255.0);
				ColorR2 = (float) (r/255.0);
				ColorG2 = (float) (g/255.0);
				ColorB2 = (float) (b/255.0);
			}

			void Set_FSTForce (float a, float r, float g, float b) 
			{
				ColorA3 = (float) (a/255.0);
				ColorR3 = (float) (r/255.0);
				ColorG3 = (float) (g/255.0);
				ColorB3 = (float) (b/255.0);
			}

			void Set_FSLForce (float a, float r, float g, float b) 
			{
				ColorA4 = (float) (a/255.0);
				ColorR4 = (float) (r/255.0);
				ColorG4 = (float) (g/255.0);
				ColorB4 = (float) (b/255.0);
			}

			void Set_RangeForce (float a, float r, float g, float b) 
			{
				ColorA5 = (float) (a/255.0);
				ColorR5 = (float) (r/255.0);
				ColorG5 = (float) (g/255.0);
				ColorB5 = (float) (b/255.0);
			}

			void Set_AdditForce (float a, float r, float g, float b) 
			{
				ColorA6 = (float) (a/255.0);
				ColorR6 = (float) (r/255.0);
				ColorG6 = (float) (g/255.0);
				ColorB6 = (float) (b/255.0);
			}

			void Set_TargetF (float a, float r, float g, float b) 
			{
				ColorA7 = (float) (a/255.0);
				ColorR7 = (float) (r/255.0);
				ColorG7 = (float) (g/255.0);
				ColorB7 = (float) (b/255.0);
			}

			void Set_TargetP (float a, float r, float g, float b) 
			{
				ColorA8 = (float) (a/255.0);
				ColorR8 = (float) (r/255.0);
				ColorG8 = (float) (g/255.0);
				ColorB8 = (float) (b/255.0);
			}

			void Set_LineWidth (float a, float r, float g, float b, float d, float c, float e, float f)
			{
				MeaLineW      = (float) (a);
				MeaLineWA     = (float) (c);
				SimLineW      = (float) (r);
				FSTLineW      = (float) (g);
				FSLLineW      = (float) (b);
				AccuracyBound = (float) (d);
				TargetFLineW  = (float) (e);
				TargetPLineW  = (float) (f);
			}

			void Set_FileName1 (String ^s) {File1 = s;};
			void Set_FileName2 (String ^s) {File2 = s;};
			void Set_FileName3 (String ^s) {File3 = s;};

			void Get_LineWidth (float *a, float *r, float *g, float *b, float *d, float *c, float *e, float *f) 
			{
				*a = MeaLineW;
				*c = MeaLineWA;
				*r = SimLineW;
				*g = FSTLineW;
				*b = FSLLineW;
				*d = AccuracyBound;
				*e = TargetFLineW;
				*f = TargetPLineW;
			}

			int Get_M       () { return DoM;   };
			int Get_MA      () { return DoMA;  };
			int Get_F       () { return DoF;   };
			int Get_FST     () { return DoFST; };
			int Get_FSL     () { return DoFSL; };
			int Get_RANGE   () { return DoMRange; };
			int Get_Time    () { return DoTime; };
			int Get_TargetF () { return DoTargetFunction; };
			int Get_TargetP () { return DoTargetPoint; };
			int Get_Files   () { return DoFiles; };

			BOOL Draw ();
			BOOL Draw0();

			void DoFrame          (); 
			void DoPointFX        (const double x, const double y); 
			void DoPointFY        (const double x, const double y); 
			void DoPointTX        (const double x, const double y); 
			void DoPointTY        (const double x, const double y); 
			void DoScale          (); 
			void DoPlotMea        (int idir, float factor); 
			void DoPlotMeaA       (int idir, float factor); 
			void DoPlotSimF       (int idir); 
			void DoPlotSimFST     (int idir); 
			void DoPlotSimFSL     (int idir); 
			void DoPlotTimeMea    (int idir); 
			void DoPlotTimeMeaA   (int idir); 
			void DoPlotTimeSim    (int idir); 
			void DoPlotTimeTarget (int idir); 
			void DoPlotTimeSimFST (int idir); 
			void DoPlotTimeSimFSL (int idir); 
			void DestroyGLWindow  ();
			void CreateGLWindow   (GLsizei iWidth, GLsizei iHeight);
			void GeneratePicture  ( String ^s );
			BOOL   BitmapOutput   (float x,float y,char *string);
			GLvoid KillFont       (GLvoid);
			GLvoid BuildFont      (GLvoid);
			GLvoid ReSizeGL       (float width, float heigth);

			double mymax ( const double value1, const double value2 );
			double mymin ( const double value1, const double value2 );

   protected:

			HDC   m_hDC;
			HGLRC m_hglrc;
			
			GLuint	base;			// Base Display List For The Font Set
			GLint    MySetPixelFormat			(HDC hdc);
			bool	   InitGL						(GLvoid);

			String ^File1;
			String ^File2;
			String ^File3;

			FILE *LOGFILE;

			bool    UserScale,FristUserScale;
			int     DoM,DoMA,DoF,DoFST,DoFSL,DoFiles,DoMRange,DoTime;
			int     DoTargetFunction,DoTargetPoint;
			int     NumberOfFiles,NumberOfAdditionalFiles,JRange;
			int    *PointsPerFile,*TargetDirectionPerFile;
			int     pheigth,pwidth,poff,TheMessages;

			float  xscale,yscale;
			float  ColorA,ColorR,ColorG,ColorB;
			float  ColorA1,ColorR1,ColorG1,ColorB1;
			float  ColorA2,ColorR2,ColorG2,ColorB2;
			float  ColorA3,ColorR3,ColorG3,ColorB3;
			float  ColorA4,ColorR4,ColorG4,ColorB4;
			float  ColorA5,ColorR5,ColorG5,ColorB5;
			float  ColorA6,ColorR6,ColorG6,ColorB6;
			float  ColorA7,ColorR7,ColorG7,ColorB7;
			float  ColorA8,ColorR8,ColorG8,ColorB8;
			float  MeaLineW,MeaLineWA,SimLineW,FSTLineW,FSLLineW;
			float  TargetFLineW,TargetPLineW,AccuracyBound;
			double *optidata;
			double *resultdata;

			double Fxmax,Fxmin,Fymax,Fymin,Fxrange,Fyrange,Fxdelta,Fydelta;
			double sxmax,sxmin,symax,symin,sxrange,syrange,sxdelta,sydelta;
			double UFxmax,UFxmin,UFymax,UFymin;
			double Usxmax,Usxmin,Usymax,Usymin;
			double TargetFmax,TargetPmax,UTargetFmax,UTargetPmax;

			double tmax, tmin, trange, tdelta;
   };
}