#include "StdAfx.h"
#include "RMOD_K_Formula_Run.h"

CRMOD_K_Formula_Run::CRMOD_K_Formula_Run( void )
{
   myDiscreteFormula      = new CDiscreteFormula;
   myContinusFormula      = new CContinusFormula;
	myDataPointerContainer = new CDataPointerContainer(0);
	myDiscreteFormula->set_dataexchange(1);
	dataexchange = 1;
	version      = 201;
}

CRMOD_K_Formula_Run::~CRMOD_K_Formula_Run( void )
{
}
int CRMOD_K_Formula_Run::ReadFile_Formula ()
//----------------------------------------------------------------------
// --- read formula data
//----------------------------------------------------------------------
{
   FILE *INPUTDATA;
   char s[256],*s1;
   int  i=0,linecount,varcount=0,size;
	double value;
//
// --- preset output
//
   output[0] = 0.0;
   output[1] = 0.0;
   output[2] = 0.0;
   ierr      = 0;
//
// --- somebody at home?
//
   if ( ( INPUTDATA = fopen ( DataFileName,"r+" ) ) == NULL )
   {
      printf ( " unable to open input file %s for reading\n",DataFileName );
      return( 0 );
   }
//
// --- look for version and title identification
//
   fgets ( s,256,INPUTDATA );
	if ( ( s1 = strstr (s,"version") ) != NULL  ) sscanf (s1+7,"%d",&version);   else version = 201;
	myContinusFormula->set_version(version);
	myDiscreteFormula->set_version(version);
//
// --- parse input file
//
   if ( strstr ( s,"[RMFpar1]" ) )
	{
//
// --- read parameter lines
//
      linecount = get_integevalue ( s );
      for ( i=0; i<linecount; i++ )
      {
         fgets ( s,256,INPUTDATA );
         input1[varcount++] = get_doublevalue ( s );
      }
   }

   fgets ( s,256,INPUTDATA );
   if ( strstr ( s,"[RMFpar2]" ) )
   {
      linecount =+ get_integevalue ( s );
      for ( i=0; i<linecount; i++ )
      {
         fgets ( s,256,INPUTDATA );
         input1[varcount++] = get_doublevalue ( s );
      }
   }
   else
   {
      printf ( " Error in data block 2 \n" );
      ierr++;
   }

   fgets ( s,256,INPUTDATA );
   if ( strstr ( s,"[RMFpar3]" ) )
   {
      linecount =+ get_integevalue ( s );
      for ( i=0; i<linecount; i++ )
      {
         fgets ( s,256,INPUTDATA );
         input1[varcount++] = get_doublevalue ( s );
      }
   }
   else
   {
      printf ( " Error in data block 3 \n" );
      ierr++;
   }

   fgets ( s,256,INPUTDATA );
   if ( strstr ( s,"[RMFpar4]" ) )
   {
      linecount =+ get_integevalue ( s );
      for ( i=0; i<linecount; i++ )
      {
         fgets ( s,256,INPUTDATA );
         input1[varcount++] = get_doublevalue ( s );
      }
   }
   else
   {
      printf ( " Error in data block 4 \n" );
      ierr++;
   }

   fgets ( s,256,INPUTDATA );
   if ( strstr ( s,"[RMFpar5]" ) )
   {
      linecount =+ get_integevalue ( s );
      for ( i=0; i<linecount; i++ )
      {
         fgets ( s,256,INPUTDATA );
         input1[varcount++] = get_doublevalue ( s );
      }
   }
   else
   {
      printf ( " Error in data block 5 \n" );
      ierr++;
   }
//
// --- read data 
//
	if ( version >= 203 )
	{
		fgets ( s,256,INPUTDATA );
		if ( strstr ( s,"[RMFpar6]" ) )
		{
			linecount = get_integevalue ( s );
			for ( i=0; i<linecount; i++ )
			{
				fgets ( s,256,INPUTDATA );
				input1  [varcount++] = get_doublevalue ( s );
			}
		}
		else
		{
			printf ( " Error in data block 6 \n" );
			ierr++;
		}
	}
	if ( version >= 204 )
	{
// 
// --- structure for parameter LR
//
		fgets ( s,256,INPUTDATA );
		if ( strstr ( s,"[RMFpar7]" ) )
		{
			linecount = get_integevalue ( s );
			if ( linecount != 9 ) { printf ( " Error in data block 7 \n" ); ierr++; }   
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,1,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,2,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,3,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,4,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,5,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,6,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,7,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,8,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(1,9,value);
		}
		else
		{
			printf ( " Error in data block 7 \n" );
			ierr++;
		}
// 
// --- structure for par 
//
		fgets ( s,256,INPUTDATA );
		if ( strstr ( s,"[RMFpar8]" ) )
		{
			linecount = get_integevalue ( s );
			if ( linecount != 9 ) { printf ( " Error in data block 8\n" ); ierr++; }    
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,1,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,2,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,3,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,4,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,5,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,6,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,7,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,8,value);
			fgets ( s,256,INPUTDATA ); s1 = strstr (s,"=")+1; sscanf (s1,"%lf",&value); myDiscreteFormula->DiscreteFormula_SetExVariables(2,9,value);
		}
		else
		{
			printf ( " Error in data block 8 \n" );
			ierr++;
		}
	}
//
// --- read model type
//
   fgets ( s,256,INPUTDATA );
   if ( strstr ( s,"[RMFmodel]" ) )
   {
      linecount++;
      fgets ( s,256,INPUTDATA );
      s1 = strstr ( s,"=" ) + 1;
      sscanf ( s1,"%lf",&input4 );
   }
   else
   {
      printf ( " Error in data block 9 \n" );
      ierr++;
   }

   fclose ( INPUTDATA );

   model = ( int ) input4;
   m1    = varcount;
   m2    = Ninput2;
   m3    = Ninput3;
//
// --- input check ok
//
   if ( ierr == 0 )
   {
//
// --- put data to model
//
      if      ( model == 1 ) ierr = myContinusFormula->ContinusFormula_SetVariables ( input1,m1 );
      else if ( model == 2 ) ierr = myDiscreteFormula->DiscreteFormula_SetVariables ( input1,m1 );
      else
      {
         printf ( " type of model should be 1 (continuos) or 2 (discete) and not %d\n",model );
         return ( 0 );
      }
   }
//
// --- data exchange pointer
//
	if ( dataexchange )
	{
//		mypatchoutput    = myDataPointerContainer->Get_DataPointer_out(1);
		mypatchoutput.n = 20;
		mypatchoutput.m = 20;
		size = (mypatchoutput.n)*(mypatchoutput.m);
		if ( ( mypatchoutput.pointer1 = ( double * ) calloc ( size, sizeof( double ) ) ) == NULL ) return ( 6 );
		if ( ( mypatchoutput.pointer2 = ( double * ) calloc ( size, sizeof( double ) ) ) == NULL ) return ( 7 );
	}
//
// --- if something went wrong
//
   if ( ierr > 0 )
   {
      printf ( " error %d while using model %d\n",ierr,model );
   }

   return ( linecount );
}

void CRMOD_K_Formula_Run::Evaluate_Formula ()
//----------------------------------------------------------------------
// --- evaluate formula
//----------------------------------------------------------------------
{
   if      ( model == 1 ) myContinusFormula->ContinusFormula_Evaluate ( input3,output );
   else if ( model == 2 ) myDiscreteFormula->DiscreteFormula_Evaluate ( input3,output );
   else
   {
      printf ( " type of model should be 1 (continuos) or 2 (discete) and not %d\n",model );
   }
}
void CRMOD_K_Formula_Run::GetSize_Formula ( double *Area, double *h, double *b, double *dA )
//----------------------------------------------------------------------------------------------
// --- evaluate formula
//----------------------------------------------------------------------------------------------
{
   if      ( model == 1 )
   {
      *Area = myContinusFormula->get_area();
      *h    = myContinusFormula->get_length();
      *b    = myContinusFormula->get_width();
		*dA   = (*h)*(*b);
   }
   else if ( model == 2 )
   {
      *Area = myDiscreteFormula->get_area();
      *h    = myDiscreteFormula->get_length();
      *b    = myDiscreteFormula->get_width();
		*dA   = myDiscreteFormula->get_dA();
   }
   else
   {
      printf ( " type of model should be 1 (continuos) or 2 (discete) and not %d\n",model );
   }
}
void CRMOD_K_Formula_Run::get_charvalue ( const char *s, char *s2 )
//----------------------------------------------------------------------
// --- get double value out of s past next =
//----------------------------------------------------------------------
{
   const char *s1;

   s1 = strstr ( s,"=" ) - 1;
   strncpy (s2,s,strlen(s)-strlen(s1));
}
int CRMOD_K_Formula_Run::get_integevalue ( const char *s )
//----------------------------------------------------------------------
// --- get integer value out of s past next =
//----------------------------------------------------------------------
{
   int  ivalue;
   const char *s1;

   s1 = strstr ( s,"=" ) + 1;
   sscanf ( s1,"%d", &ivalue );
   return ( ivalue );
}
double CRMOD_K_Formula_Run::get_doublevalue ( const char *s )
//----------------------------------------------------------------------
// --- get double value out of s past next =
//----------------------------------------------------------------------
{
   double  value;
   const char *s1;

   s1 = strstr ( s,"=" ) + 1;
   sscanf ( s1,"%lf", &value );
   return ( value );
}
