#pragma once
#include "DiscreteFormula.h"
#include "ContinusFormula.h"
#include "FormulaDefines.h"
#include <string.h>

class CRMOD_K_Formula_Run
{

public:
   CRMOD_K_Formula_Run( void );
  ~CRMOD_K_Formula_Run( void );

	CDataPointerContainer *myDataPointerContainer;

   char DataFileName[256];

   int ReadFile_Formula      ();
   void Evaluate_Formula     ();
   void GetSize_Formula      ( double *Area, double *h, double *b, double *dA );
   void Initialize           () {myDiscreteFormula->DiscreteFormula_Initialize();};
   void   get_charvalue      ( const char *s, char *s2 );
   int    get_integevalue    ( const char *s );
   double get_doublevalue    ( const char *s );

   inline void set_draw3d       ( int mode ) {myDiscreteFormula->set_draw3d      ( mode );};
   inline void set_dataexchange ( int mode ) {myDiscreteFormula->set_dataexchange( mode );};

   int     m1,dataexchange,version;
   double  input1[NMODELPARAMETER],input3[Ninput3],output[Noutput+4];
   double  RangeMin[Ninput3],RangeMax[Ninput3];

protected:

   int    m2,m3,ierr,model;
   double input2[Ninput2],input4;

	PATCHOUTPUT       mypatchoutput;
   CDiscreteFormula *myDiscreteFormula;
   CContinusFormula *myContinusFormula;
};
